#include <cassert>
#include "xunix.h"
#include "xutil.h"

const char* xutil::basename(const char* fullpath) {
  const char* rv = 0;
  const char* tmp = 0;
  assert(fullpath);
  tmp = fullpath;
  for( ; *tmp != '\0' ; ++tmp ) {
    if( *tmp == '/' ) {
      rv = tmp;
    }
  }
  return rv ? ++rv : fullpath;
}

void xutil::install_signal_handler(int sig, void (*f)(int)) {
  struct sigaction sigact = {{0}};
  sigact.sa_handler = f;
  sigact.sa_flags = 0;
  xunix::sigemptyset(&sigact.sa_mask);
  xunix::sigaction(sig, &sigact, 0);
}
